console.log('loading app.js');

// Declare global vars
var previousPage = '';
var currentPage = '';
var nextPage = '';
var branchTo = '';
var pad = {};
var urlId = '';
var uid = '';
var mode = '';
var token = '';
var tour = '';
var myDate = '';
var url_id = '';
var currentGuest = '';
var pad = {};

var enabled = {};
// photoscans is number of tag scans on photo scan page
var photoScans = 0;
// list of photoScan tags
var photoTags = [];
var barcoding = false;
// timeOut is used for code lookup
var timeOut;
var message = '';
// codeGuestID is set to guest ID of person after code lookup
var codeGuestID = '';
var currentEvent;
var eventList;
//last scene before rfid read
var lastPreRfid = "";

/*function zoneTagUpdate()
{
	var activeTagsArr = getActiveTags(true);
	var inactiveTagsArr = getInactiveTags(true);
	
	//var currentTimeDate = new Date();
	//var timeStr = currentTimeDate.toString();
	
	//console.log(timeStr + " getActiveTags: " + JSON.stringify(activeTagsArr));
	//console.log(timeStr + " getInactiveTags: " + JSON.stringify(inactiveTagsArr));
	
	setTimeout(function(){tagPopulateDiv(activeTagsArr,inactiveTagsArr);},100);
}*/

var lastRecordVisitBatch = 0;

function recordVisitBatchMonitor(){// used only when zone management enabled
//	log("recordVisitBatchMonitor. waitingforLowLevel: "+waitingForLowLevel.toString());
	if(!waitingForLowLevel) readFile("saveRecordVisit.txt",saveRecordVisitProcess);
	setTimeout("recordVisitBatchMonitor();",60000);
}

var sendSingleVisits = false;
var sendBatchVisits = true;

function isTestTag(tag){
	if(tag >= zoneConfig["testTagStart"] && tag <= zoneConfig["testTagEnd"]) return true;
}

function conv(pStr) {
        tempstr = '';
        if(pStr.length != 16) return "0";
        for (a = 0; a < pStr.length; a = a + 2) {
        	var t1 = pStr.charAt(a);
        	if(t1 != "3") return "0";
        	var t2 = pStr.charAt(a+1);
        	var v = parseInt(t2);
        	if(v >= 0 && v <= 9) tempstr += v; else return "0";
        }
        return tempstr;
    }

function zoneTagUpdate()
{
/*	if(typeof eventData["supports_visit_batch"] != 'undefined'){
		if(eventData["supports_visit_batch"] == "false"){
		  //log("setting for single visits only");
		  sendBatchVisits = false;
		  
		  
		  sendSingleVisits = true;
		} else{
		 //log("setting for batch visits only");
		 sendBatchVisits = true;
		 sendSingleVisits = false;
		}
	}*/
	var activeTagsArr = getActiveTags(false);
	var activeTagsArrNotReportedKeys = Object.keys(activeTagsArr);
//	if(activeTagsArrNotReportedKeys.length > 0) log("zoneTagUpdate. new active tags: "+JSON.stringify(activeTagsArr));
	var inactiveTagsArr = getInactiveTags(false);
	var inactiveTagsArrNotReportedKeys = Object.keys(inactiveTagsArr);
//	if(inactiveTagsArrNotReportedKeys.length > 0) log("zoneTagUpdate. new inactive tags: "+JSON.stringify(inactiveTagsArr));
	if(zoneConfig["recordDwellVisits"]==true){
		for(var i = 0; i < inactiveTagsArrNotReportedKeys.length; i++)
		{
			var tag = inactiveTagsArrNotReportedKeys[i];
			var tagc = conv(tag);
			if(isTestTag(tagc)){
				log("recording test tag exit visit: "+tag);
			} else {
				log("recording exit visit: "+tag);
				saveRecordVisitGivenRfid(tag,"exit");//bn test patch
			}
			//sendRecordVisitGivenRfid(tag,"exit");
	//		var idx = inactiveTagsUnreported.indexOf(val);
	//		if(idx != -1) inactiveTagsUnreported.splice(idx,1);
	//		inactiveTagsUnreported.unshift(val);
		}
		
		for(var i = 0; i < activeTagsArrNotReportedKeys.length; i++)
		{
			var tag = activeTagsArrNotReportedKeys[i];
			var tagc = conv(tag);
			//log("conversion: "+tagc.toString());
			if(isTestTag(tagc)){
				log("recording test tag entry visit: "+tag);
			} else {
				log("recording entry visit: "+tag);
				saveRecordVisitGivenRfid(tag,"entry");//bn
				//sendRecordVisitGivenRfid(tag,"entry");
			}
		}
	}
	
	
	lastActiveTags = activeTagsArr;
	lastInactiveTags = inactiveTagsArr;
	
}

function saveRecordVisitProcess(visits){
	if(visits == "") return;
	log("sending visit batch file");
	sendSaveRecordVisitBatch(visits);
	writeFile("saveRecordVisit.txt","");
}

function zoneReadFinished()
{
	log("zoneReadFinished.");
	if(eventData["tapTower"] != "False" && zoneConfig["enableZoneManagement"]){
		enableZoneManagement();
		setInterval("zoneTagUpdate();",2000);
	}
	
// Enable the following to start simulation	
//************

	args = new Object();
	args.baseLongReach = "0001"; // typically station id
	args.baseShortReach = "1001"; // typically station id + 1000
	args.minTimeLongReach = "1000"; // 1 seconds - arrival
	args.maxTimeLongReach = "60000"; // 60 seconds - arrival
	args.minDwellLongReach = "10000";
	args.maxDwellLongReach = "300000";
	args.minTimeShortReach = "10000"; // 10 seconds
	args.maxTimeShortReach = "60000"; // 60 seconds
	args.duration = "36000000"; // 10 hour
	args = JSON.stringify(args);
//	callC("enableZoneSimulation;"+args);
// *************
}

var loadingApp = false;
function loadApp(mode){
	if(loadingApp) return;
	loadingApp = true;
    log('loadApp - starting, mode = '+mode+'...');
    currentPage = '';
    $('#content').hide();
	$('#content').empty();
	newMode = mode;
	if(typeof appCache[mode] !== 'undefined'){
		log("loading app from cache");
		$('#content').html(appCache[mode]);
		setTimeout("loadApp3();",100);
		return;
	}

	setTimeout("loadApp2();",200);
//	loadApp2();
}

var newMode = "";
var appCache = {};

function loadApp2(){
     // Load the form object from path/to/form.json
    // $.getJSON('configuration/settings.json', function (data) {
    //     var j = JSON.stringify(data);
    //     console.log('data = '+j);
    //     $('#content').dform(j);
    // });
    log("loadApp2");
	 var url = 'configuration/'+newMode+'.json';
    $('#content').dform(url, function(data) {
          this //-> Generated $('#myform')
          data //-> data from path/to/form.json

		  setTimeout("loadApp3();",300);
 	});
}

function loadApp3(){
		log("loadApp3");
        // init the ValidationEngine option for all forms
        
        if(typeof appCache[newMode] === 'undefined') appCache[newMode] = $('#content').html();

        try
        {
            var numForms = $("form").length;
            if(numForms > 0)
                jQuery('form').validationEngine('attach', { promptPosition : "topLeft",  autoPositionUpdate : true, autoHidePrompt : true, autoHideDelay : 6000, focusFirstField : true, scroll : false, validationEventTrigger : "none"});
        }
        catch(err)
        {
            log("validationengine warning");
        }
    
        // inits all app specific events/functions
        initMode(newMode);

        // set currentPage to the first page, and go to it
        fs_tag.guardTimer = performance.now();
        log("setting tag guard timer: "+fs_tag.guardTimer.toString());
        currentPage = $('.page:first').attr('id');
        
        setTimeout("loadingApp=false;route('"+currentPage+"')",300);

	$('#content').show();
    log('loadApp - done.');

    if(windowsMode) setTimeout('callC("setupTextboxEvents;");',1000);
}

function clickBack(){
//	$('.background').touchstart();
	log("visible: "+$('.page:visible').attr('id'));
	setTimeout("clickBack();",1000);
}

//clickBack();//bn test

function passValueEmailPhone(id){
    if ($('#email').val().length > 0){
        $('#email-remote-value').val($('#email').val());
        $('#email-deliver-value').val($('#email').val());
    }
    if ($('#phone').val().length > 0){
        $('#sms-remote-value').val($('#phone').val());
        $('#sms-deliver-value').val($('#phone').val());
    }
}

function successAuth(){
    branching();
}

function failAuth(){
    route("remoteFacebookAuth");
}

function generateDOBSelectLists() {
	var d = new Date();
    var months = [ "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December" ];
    for (var i=1;i<(months.length + 1);i++) {
        $('#DOBMonth').append('<option value="'+i+'">'+months[i-1]+'</option>');
    }
    for (var i=1;i<32;i++) {
        $('#DOBDay').append('<option value="'+i+'">'+i+'</option>');
    }
    var yearLimit = d.getFullYear() - 101;
    for (var i=(d.getFullYear() - 1);i>yearLimit;i--) {
        $('#DOBYear').append('<option value="'+i+'">'+i+'</option>');
    }
}

function numberRange(start,end,id){
    for (var i=start; i<end; ++i){
        $('#'+id).append('<option value="'+i+'">'+i+'</option>')
    }
}

function codeFound(data){
    changeScene('#selectUser');
}

function codeNotFound(){
    var codeType = codeOrEmail($('#code').val());
    if (codeType === 'url_id'){
        codeType = 'Code';
    }else{
        codeType = 'Email';
    }
    route('enterCode');
    jAlert('Please re-enter your code or e-mail', codeType+' Not Found!');
    $('#code').val('');
}

function getAge() {	
    var month = $('#dobmonth').val();
    var day = $('#dobday').val();
    var year = $('#dobyear').val();
    var datestr = year+'/'+month+'/'+day;
    var today = new Date();
    var birthDate = new Date(datestr);
    age = today.getFullYear() - birthDate.getFullYear();
    var m = today.getMonth() - birthDate.getMonth();
    if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
        age--;
    }
    if (age !== 0 && age != null) { 
        return age;
    } else {
        return 0;
    }
}

// if facebook timesout
function facebookError(){
    $('#remoteFacebookAuth').addClass('enabled');
    changePage('remoteFacebookAuth');
}

function twitterError(){
    $('#remoteFacebookAuth').addClass('enabled');
    changePage('remoteFacebookAuth');
}

// Common server calls
function sendFacebookAuthRfid(dtype){
    var args = new Object;
    log("sendFacebookAuth - sending FB auth for RFID = "+lastTagId);
    if (dtype === 'sms') {
        args.forced_type = 'sms';
        //args.forced_to = pad.Phone;
    } else if (dtype === 'email') {
        args.forced_type = 'email';
        //args.forced_to = pad.Email;
    }
    args.guest_id = lastTagId;
    args.id_type = 'RFID Tag ID';
    sendCommand('send_facebook_auth', args);
}

function sendFacebookAuthGuestId(dtype){
    var args = new Object;
    log("sendFacebookAuth - sending FB auth for Guest ID = "+currentGuest);
    if (dtype === 'sms') {
        args.forced_type = 'sms';
        //args.forced_to = pad.Phone;
    } else if (dtype === 'email') {
        args.forced_type = 'email';
        //args.forced_to = pad.Email;
    }
    args.guest_id = currentGuest;
    args.id_type = 'Guest ID';
    sendCommand('send_facebook_auth', args);
}

function sendTwitterAuthRfid(dtype){
    var args = new Object;
    log("sendTwitterAuth - sending Twitter auth for RFID = "+lastTagId);
    if (dtype === 'sms') {
        args.forced_type = 'sms';
        //args.forced_to = pad.Phone;
    } else if (dtype === 'email') {
        args.forced_type = 'email';
        //args.forced_to = pad.Email;
    }
    args.guest_id = lastTagId;
    args.id_type = 'RFID Tag ID';
    sendCommand('send_twitter_auth', args);
}

function sendTwitterAuthGuestId(dtype){
    var args = new Object;
    log("sendTwitterAuth - sending Twitter auth for Guest ID = "+currentGuest);
    if (dtype === 'sms') {
        args.forced_type = 'sms';
        //args.forced_to = pad.Phone;
    } else if (dtype === 'email') {
        args.forced_type = 'email';
        //args.forced_to = pad.Email;
    }
    args.guest_id = currentGuest;
    args.id_type = 'Guest ID';
    sendCommand('send_twitter_auth', args);
}

function saveCode()
{
    log("saving code");

    var args = new Object;
    var mypad = {};
    mypad["RFID Tag ID"] = lastTagId;
    args.id_type = "Guest ID";
    var jpad = JSON.stringify(mypad);
    args.pad = jpad;
    args.id_ = codeGuestID;
    //alert(JSON.stringify(args));
    sendCommand("set_pad",args);
    sendMessage();
};

function setPadRfid(){
    pad["RFID Tag ID"] = lastTagId;
    var _pad = {};
    for (var key in pad) {
    	_pad[key] = escape(pad[key]);
    }
    var args = new Object;
    args.id_ = lastTagId;    /// implement as not "combined" for now
    args.id_type = "RFID Tag ID";
    args.pad = JSON.stringify(_pad);
    sendCommand("set_pad",args);
}

function setPadGuestId(){
    pad["Guest ID"] = currentGuest;
    if (lastTagId != '') {
    	pad["RFID Tag ID"] = lastTagId;
    }
    var _pad = {};
    for (var key in pad) {
    	_pad[key] = escape(pad[key]);
    }
    var args = new Object;
    args.id_ = currentGuest;    /// implement as not "combined" for now
    args.id_type = "Guest ID";
    args.pad = JSON.stringify(_pad);
    sendCommand("set_pad",args);
}

function sendMessage(msg){
    if (message === ''){
        return;
    }
    if (msg) {
        message = msg;
    }
    //alert('send_message '+lastTagId);
    var args = new Object;
    args.guest_id = lastTagId;
    args.message_name = message;
    args.id_type = "RFID Tag ID";
    // alert(JSON.stringify(args, null, 4));
    sendCommand("send_message",args);
}

function sendMessageRfid(msg){
    log("sendMessageRFID - message name = "+msg);
    if (!msg) {
        return;
    }
    var args = new Object;
    args.guest_id = lastTagId;
    args.message_name = msg;
    args.id_type = "RFID Tag ID";
    sendCommand("send_message",args);
}

function sendMessageGuestId(msg){
    if (!msg) {
        return;
    }
    var args = new Object;
    args.guest_id = currentGuest;
    args.message_name = msg;
    args.id_type = "Guest ID";
    sendCommand("send_message",args);
}

function sendPhoto(msg){
    var d = new Date();
    var args = new Object;

    var i = lastTagId;
    var I = photoTags.indexOf(i);
    photoTags.splice(I,1);

    args.guest_id = lastTagId;
    args.id_type = "RFID Tag ID";
    args.photo_name = "photos/"+lastTagId+"_"+d.getTime()+".jpg";
    args.time_stamp = d.getTime();
    args.buddies = photoTags;

    args.photo = "%%photo%%";
    args.message_name = msg;
    //log("args = "+JSON.stringify(args));
    sendCommand("upload_photo",args);
}

function sendPhotoRfid(msg){
    var d = new Date();
    var args = new Object;

    var i = lastTagId;
    var I = photoTags.indexOf(i);
    photoTags.splice(I,1);

    args.guest_id = lastTagId;
    args.id_type = "RFID Tag ID";
    args.photo_name = "photos/"+lastTagId+"_"+d.getTime()+".jpg";
    args.time_stamp = d.getTime();
    args.buddies = photoTags;

    args.photo = "%%photo%%";
    args.message_name = msg;
    log("args = "+JSON.stringify(args));
    sendCommand("upload_photo",args);
}

function sendPhotoGuestId(msg){
    var d = new Date();
    var args = new Object;

    var i = lastTagId;
    var I = photoTags.indexOf(i);
    photoTags.splice(I,1);

    args.guest_id = currentGuest;
    args.id_type = "Guest ID";
    args.photo_name = "photos/"+currentGuest+"_"+d.getTime()+".jpg";
    args.time_stamp = d.getTime();
    args.buddies = photoTags;

    args.photo = "%%photo%%";
    args.message_name = msg;
    //log("args = "+JSON.stringify(args));
    sendCommand("upload_photo",args);
}

function sendRecordVisit(id, context){
    var d = new Date();
    var args = new Object;
    args.guest_id = id;
    //args["rfid_tag_id"] = id;
    args.id_type = "RFID Tag ID";
    args.context = context;
    args.client_name = eventData.Station_name;
    args.request_timestamp = Math.floor(d.getTime()/1000);
    sendCommand("record_visit",args);
    incCheckins();
}

function sendRecordVisitRfid(context){
    var d = new Date();
    var args = new Object;
    args.guest_id = lastTagId;
    args.id_type = "RFID Tag ID";
    args.context = context;
    args.client_name = eventData.Station_name;
    args.request_timestamp = Math.floor(d.getTime()/1000);
    sendCommand("record_visit",args);
    incCheckins();
}

function sendRecordVisitGuestId(context){
    var d = new Date();
    var args = new Object;
    args.guest_id = currentGuest;
    args.id_type = "Guest ID";
    args.context = context;
    args.client_name = eventData.Station_name;
    args.request_timestamp = Math.floor(d.getTime()/1000);
    sendCommand("record_visit",args);
    incCheckins();
}

function sendRecordVisitGivenType(id, context,type){
    var d = new Date();
    var args = new Object;
    args.guest_id = id;
    //args["rfid_tag_id"] = id;
    args.id_type = type;
    args.context = context;
    args.client_name = eventData.Station_name;
    args.request_timestamp = Math.floor(d.getTime()/1000);
    sendCommand("record_visit",args);
    incCheckins();
}

function sendRecordVisitGivenRfid(id, context){
    var d = new Date();
    var args = new Object;
    args.guest_id = id;
    args.id_type = "RFID Tag ID";
    args.context = context;
    args.client_name = eventData.Station_name;
    args.request_timestamp = Math.floor(d.getTime()/1000);
    sendCommand("record_visit",args);
    incCheckins();
}

function saveRecordVisitGivenRfid(id, context){
    var d = new Date();
    var args = new Object;
    var out = id+","+context+","+Math.floor(d.getTime()/1000)+"%%";
    appendFile("saveRecordVisit.txt",out);
}

function sendSaveRecordVisitBatch(visits){
	log("sendSaveRecordVisitBatch called: "+visits);
	return;
    var d = new Date();
    var args = new Object;
    var v = visits.split("%%");
    var o = [];
    
    for(var i = 0; i < v.length;i++){
    	var t = v[i].split(",");
    	if(t.length < 3) continue;
    	o[i] = t;
    }
    args.visits = o;
    args.id_type = "RFID Tag ID";
    args.client_name = eventData.Station_name;
    args.request_timestamp = Math.floor(d.getTime()/1000);
    sendCommand("record_visit_batch",args);
}

function timeout_init(){
    timeOut = setTimeout(codeNotFound, 10000);
}

function timeout_clear() {
    clearTimeout(timeOut);
}

function lookupCodeCallback(data) {
    log("lookupCodeCallback: "+currentPage);
    if(currentPage != "#codeLookUp") return;
    var result = data['result'];

    if (result.length <1) {
        log("lookupCodeCallback: Code not found...");
        timeout_clear();
        codeNotFound();
        $('#code').val('');
    } else {
        log("lookupCodeCallback: Code found, setting variables...")
            timeout_clear();
        for (var i=0; i < result.length;i++){
            codeGuestID = result[i]['Guest ID'];
            var myName = result[i]['First Name']+' '+result[i]['Last Name'];
            $('#selectUserList').append('<option value="'+codeGuestID+'">'+myName+'</option>');
        }
        codeFound();
    } 
    log("lookupCodeCallback: done.");
}

function lookupPersonCallback(data) {
    log("lookupPersonCallback: "+currentPage);
    if(currentPage != "#sigLookUp") return;
    var result = data['result'];
    if (result.length <1) {
        log("lookupPersonCallback: Person not found...");
        timeout_clear();
        notFound();
        $('#fname').val('');
        $('#lname').val('');
    } else {
        log("lookupPersonCallback: Person found, setting variables...")
            timeout_clear();
        var person = result[0];
        tagName = person['First Name'] + ' ' + person['Last Name'];
        firstName = person['First Name'];
        lastName = person['Last Name'];
        $('#fname').val(firstName);
        $('#lname').val(lastName);
        var datestr = person['DOB Year']+'/'+person['DOB Month']+'/'+person['DOB Day'];
        var today = new Date();
        var birthDate = new Date(datestr);
        tagAge = today.getFullYear() - birthDate.getFullYear();
        var m = today.getMonth() - birthDate.getMonth();
        if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
            tagAge--;
        }
        found();
    } 
    log("lookupPersonCallback: done.");
}

function init(){
	/*
    $('#content').empty();
    $('.retake').hide();
    $('#email-deliver-value').parent().hide();
    $('#sms-deliver-value').parent().hide();
    $('#facebook-deliver-value').parent().hide();
    $('#sms-remote-value').parent().hide();
    $('#email-remote-value').parent().hide();
    $('input[type=text]').val('');
    $('input[type=tel]').val('');
    $('input[type=number]').val('');
    $('input[type=email]').val('');
    $(':checked').prop({checked: false});
    $(':selected').prop({selected: false});
    */
    pad = {};
    //tagmapping = eventData['wristband_mapping'];
    if(rfidShortReachTestRunning) controlRfidShortReachTest(); // stops short reach test if active
                                                               // ** note that if simulation is active it will continue to run**
                                                             
	inpanel = false;
	lowerIconTouched = false;
    fs_tag.init(eventData["wristband_mapping"]);

    lastAuthToken = "";
    message = '';
    codeGuestID = '';
    lastPreRfid = '';
    currentGuest = '';
    lastTagId = '';
    rfidReadSuccess = singleRfidReadSuccess;
    gpsReadSuccess = null;
    zoneStateHandler = zoneTagUpdate;
   	zoneReadFinishedCallback = zoneReadFinished;
   	if(muxLocked) unlockMux();
}

$(document).ready(function() {
    //$("select").selecter();
/*    $("#eventUID").selecter({
        width:"95%",marginLeft:"10px"
    });*/
     if(windowsMode) setTimeout('callC("setupTextboxEvents;");',1000);
    log('document ready - starting...');
    //fastClick, removes 300ms delay on taps
    if($(".panelIcon").length == 0){
    	adaptIndex();
    } else fixIcons();
    window.addEventListener('load', function() {
        new FastClick(document);
    }, false);
    
    document.addEventListener('touchstart', function(event) {
        var $target = $(event.target);
        if ($target.hasClass('button') || $target.hasClass('smbutton')){
            $target.addClass('active');
        }
    }, false);
    
    document.addEventListener('touchend', function(event) {
        var $target = $(event.target);
        if ($target.hasClass('button') || $target.hasClass('smbutton')){
            $target.removeClass('active');
        }
    }, false); 
    
 //  	clearZoneFile();
   		//clearZoneConfigFile();
 //   readZoneConfig();


	// readCounts reads the persisted counts.json, which is the total
	// of all regs, checkins, etc.  This function only reads in the file
	// and has no other effects.
    readCounts();
    
    // Manually invoke refresh control on C# side, which populates
    // eventData and eventStatus global variables.  refreshControl
    // will then call readyDocument (defined below) on the first run.
    log('document ready - invoking refreshControl');
    setFirstRun();
    invokeRefreshControl();
    setTimeout("readyDocument();",1000);
    
    //setRfidTransition("");
});

function readyDocument() {
// This function is for all intents and purposes "document.ready".
// Because we persist to eventData, we need for it to be repopulated
// before the rest of the app loads.

/*document.addEventListener( 'touchstart', function(e){ onStart(e); }, false );
    function onStart ( touchEvent ) {
      if( navigator.userAgent.match(/Android/i) ) {
        touchEvent.preventDefault();
      }
    } */
log('readyDocument entry');
if(eventData["tapTower"] != "False" && !androidUndefined ){
   	clearZoneFile();
   		//clearZoneConfigFile();
    readZoneConfig();
	setTimeout("recordVisitBatchMonitor();",60000);
}

init();

// init generic events common to all apps
genericModeInit();

// load the app to start with.  var startingPage is defined
// at the top of router.js
log('document ready - loading app startingPage = '+startingPage);

lowLevelMonitor();
statsUpdateMonitor();
startReader();
loadApp(startingPage);
//$('.menuIcon').removeClass('menuIcon4').addClass('menuIcon1');
}

