//
// log in functions
//
log('loading... login.js');

var loginScript;
var loginTimer = null;
var loggedInPerson = {};

function login_timer_init(){
    log('init login_timer');
    loginTimer = setTimeout(function(){route('error-page')}, 10000);
}

function login_timmer_clear(){
    log('clear login_timer');
    clearTimeout(loginTimer);
}

function my_login(){
    // temp function to switch server
    tempSwitchSever();
    
    login_timer_init();
    var d = new Date();
    var args = new Object;
    var pid = $('#email').val();
    var emailCheck = pid.search("@");
    if (emailCheck != -1){
        pid = 'e|'+pid;
    }
    args.ParticipantId = pid;
    args['Password'] = $('#password').val();
    setTimeout(function(){ sendCommand('search_login',args,login_callback)}, 100);
}

function login_callback(data){
    login_timmer_clear();
    var result = null;

    try{
        result = data;
     //   log(JSON.stringify(result, null, '\t'));
    }catch(e){
        log('login ERROR: '+data);
        route('error-page');
        $('.msg').text(data);
        return;
    }
    if (result == null || typeof result == undefined ){
        log('network ERRROR: bad communitation with server');
        route('error-page');
        $('.msg').text('network ERROR: bad communitation with server');
        return;
    }
    if (result.length < 1 || result['status'] === false){
        log('user not found');
        route('error-page');
        $('.msg').text('User not found or User Name and Password are wrong.');
        return;
    }
    if (result['status'] === true){
        log('User Found, setting vars...');
        //log(JSON.stringify(result, null, '\t'));
        loggedInPerson = result['data'];
        clearFields();
        loadApp('settings');
        if (loggedInPerson['BadgeFirstName'] != undefined){
            $('.fullName').text(loggedInPerson['BadgeFirstName']+' '+loggedInPerson['BadgeLastName']);
        }
    }
}

