var  tag =  {
    "barcode": {
        "type": "string",
        "offset": 0,
        "count": 8
    }
};

var  tag =  {
	    
	    "first_init": {
	    	"type": "string",
	    	"offset": 0,
	    	"count": 1
	    },

	    "last_name": {
	    	"type": "string",
	    	"offset": 1,
	    	"count": 3
	    },

	    "checksum": {
	    	"type": "uint32",
	    	"offset": 4
	    }

    };
    

var barcoding = false;
var mode = '';

$(document).ready(function() {
	changePage("settings");
	//barcodeEnabled();
	minimeEnabled();
	//callC("logCallout;");
	zoneStateHandler = zoneTagUpdate;
   	zoneReadFinishedCallback = zoneReadFinished;
	clearZoneFile();
   	clearZoneConfigFile();
    readZoneConfig();
    
    $( 'btn_read' ).on( 'touchstart',function(){
         readRfid();
      });
     $( 'btn_write' ).on( 'touchstart',function(){
         writeRfid();
      });
    //testChromaSettings();
});

function setPowerLevel()
{
	var wantedPowerLevel = $("#wantedPowerLevel").val();
	callC("power;" + wantedPowerLevel);
}

function setChromaSettings()
{
	var chromaSettings = {};
	chromaSettings["hue"] = "121.0";
	chromaSettings["tolerance"] = "10.1";
	var chromaSettingsStr = JSON.stringify(chromaSettings);
	callC("setChromaKeySettings;" + chromaSettingsStr);
}

function zoneReadFinished()
{
	log("zoneReadFinished.");
	lowLevelMonitor();
	statsUpdateMonitor();
	startReader();
	//enableZoneManagement();
	//setInterval("zoneTagUpdate();",2000);
}

function zoneTagUpdate()
{
	var activeTagsArr = getActiveTags(false);
	var activeTagsArrNotReportedKeys = Object.keys(activeTagsArr);
	if(activeTagsArrNotReportedKeys.length > 0) log("zoneTagUpdate. new active tags: "+JSON.stringify(activeTagsArr));
	var inactiveTagsArr = getInactiveTags(false);
	//console.log("zoneTagUpdate. inactive tags: " + inactiveTagsArr.toString();
	//console.log("zoneTagUpdate. inactive tags after");
	var inactiveTagsArrNotReportedKeys = Object.keys(inactiveTagsArr);
	if(inactiveTagsArrNotReportedKeys.length > 0) log("zoneTagUpdate. new inactive tags: "+JSON.stringify(inactiveTagsArr));
	
	//var inactiveTagsArrNotReported = getInactiveTags(false);
	/*var inactiveTagsArrNotReportedKeys = Object.keys(inactiveTagsArr);
	for(var i = 0; i < inactiveTagsArrNotReportedKeys.length; i++)
	{
		var val = inactiveTagsArrNotReportedKeys[i];
		var idx = inactiveTagsUnreported.indexOf(val);
		if(idx != -1) inactiveTagsUnreported.splice(idx,1);
		inactiveTagsUnreported.unshift(val);
	}*/
	
	
	lastActiveTags = activeTagsArr;
	lastInactiveTags = inactiveTagsArr;
	
	//var currentTimeDate = new Date();
	//var timeStr = currentTimeDate.toString();
	
	//console.log(timeStr + " getActiveTags: " + JSON.stringify(activeTagsArr));
	//console.log(timeStr + " getInactiveTags: " + JSON.stringify(inactiveTagsArr));
}


function startVideoTest()
{
	callC('photoCaptureSize;320x240');
	callC("videoRecordingParameters;30,1500000"); // framerate,bitrate
	callC('videoCamera;');
	//setTimeout("callC('startVideo');",2000);
	//setTimeout("callC('stopVideo');",5000);
}

function startPhotoTest()
{
//	callC('photoCaptureSize;640x480');
	//callC('photoCaptureSize;{"height": "640","width": "480"}');
	callC('photoCaptureSize;{"height": "720","width": "1280"}');
	
	callC("camera;");
	//callC("camera4;external");
}

function displayVideo(path)
{
	$("#video").attr('src',path);
	$("#video")[0].play();
}

var sensed = false;
var wasSensing = false;

testSensing();

function testSensing(){
	if(wasSensing){
		if(!sensed){
		  $("#log").html("");
		  wasSensing = false;
		 }
		sensed = false;
	}
	setTimeout('testSensing();',2000);
}

function log2(str)
{
	var disp = false;
	if(str.indexOf("FRAG_Tag") != -1){
		str = "RFID READER ATTACHED";
		disp = true;
	}
	if(str.indexOf("mode: read") != -1){
		str = "WAITING FOR TAG READ SCAN";
		disp = true;
	}
	if(str.indexOf("mode: write") != -1){
		str = "WAITING FOR TAG WRITE SCAN";
		disp = true;
	}
	if(str.indexOf("found tag") != -1){
		str = "SENSING TAG";
		wasSensing = true;
		sensed = true;
		disp = true;
	}
	
    var curHTML = $("#log").html();
    $("#log").html(str + "<br/>" + curHTML);
	 if(disp) $("#log").html(str );
}

function log3(str){
 	var curHTML = $("#log").html();
     $("#log").html(str + "<br/>" + curHTML);
//	$("#log3").html(str );
}

function readBarcode(){
	log("request to read barcode");
	log3("");
	barcode = true;
	rfidWrite = false;
	rfidReadAfterWrite = false;
	callC("readBarcode;");
}

var lastBarcode = "";
var barcode = false;
var rfidWrite = false;
var rfidReadAfterWrite = false;
var lastBarcode = "";
var init = false;

function rfidReadSuccess(){
	log3("read: "+lastTagId);
	log("rfidReadSuccess barcode: "+barcode.toString()+" rfidWrite: "+rfidWrite.toString()+" rfidReadAfterWrite: "+rfidReadAfterWrite.toString()+" writeStatus: "+fs_tag.writeStatus);
	return; /// special test
	if(barcode){
		var tmp = lastTagId.split("$");
		lastBarcode = tmp[0];
		$("#lastbc").val(lastBarcode);
	} else {
		lastBarcode = $("#lastbc").val();
		if(rfidWrite){
			if(fs_tag.writeStatus != "True"){
				log3("LAST WRITE FAILED -- Please remove/rescan to retry");
				$("#lastrfdata").val();
				$("#lastrf").val(lastTagId);
//				writeRfid();
				return;
			}
			rfidReadAfterWrite = true;
			rfidWrite = false;
			$("#lastrf").val(lastTagId);
			log3("SUCCESSFUL WRITE -- Please re-read tag to verify");
			readRfid();
		} else {
			if(rfidReadAfterWrite){
			$("#lastrf").val(lastTagId);
			var tmp = fs_tag.getField("last_name");
			log("readAfterWrite test: lastBarcode: "+lastBarcode + " current read: "+tmp);
			if(tmp != lastBarcode){ // read miscompare
				log("read after write miscompare wrote: "+lastBarcode+" read: "+tmp);
				log3("Read Check Failed wrote: "+lastBarcode +" read: "+tmp);
				$("#lastrfdata").val(tmp);
			} else{
				log("Last read after write compare success");
				log3("Last read after write compare success");
				$("#lastrfdata").val(tmp);
				}
			rfidReadAfterWrite = false;
		    } else { //simple rfid read
				$("#lastrf").val(lastTagId);
				var rd = fs_tag.getField("last_name");
				log3("rfidReadSuccess simple read: lastTagId: "+$("#lastrf").val()+ " field val: "+rd);
				$("#lastrfdata").val(rd);
		    }
	    }
	}
}

function readRfid(){
	log3("");
	$("#lastrfdata").val("");
	$("#lastrf").val("");
	//callC("power;7");
	barcode = false;
	rfidWrite = false;
	fs_tag.init(tag);
	fs_tag.readFields("","");
	log("request to read rfid");
}

var tim = null;
function readRfidTag(){
	setRfidTransition("");
}

function writeRfid(){
	log3("");
//	$("#lastrfdata").val("");
	$("#lastrf").val("");
	barcode = false;
	rfidWrite = true;
	fs_tag.init(tag);
	log3("writing: "+$("#lastrfdata").val());
	//fs_tag.setField("barcode",$("#lastrfdata").val());
	fs_tag.setField("first_init","G");
	fs_tag.setField("last_name","mylastname");
	fs_tag.flushFields("");
	log("request to write rfid");
}

function setLicenses()
{
    log("setLicenses");
//    var licenses = "783ecd953d3550eb01cd059ff6a2d974db1fcb42=9e3d1b2a1b6a7fa74e40b6dea128baba,fcfd2a31dce8c75f3d22e58158348df3e3ea6458=6316f933a485041fbe1ff927c7ec9f89,b1670a110cb0f7b58c483d84e178353600dc71ab=49beaa508f372e0c63f643c84c65f744,caf7be1b14207f684927d1b35626b0589b5b8dc2=7a14b62636e0507b58a7bcca8ce797af,82343a53fe21417369fc275cd6d6b220cc9d52ab=4f2ef0207d22edadd94667a20efa5ba8,56e84dcdbd495091f3acc4216aa6ae1e9a8fe8e5=e64047e8e2b9246dcfe3577d514860ce,fc41aafa7e54aad37ef16f5ed7fb5cc9f7c61a46=10105f77236d56c58190c6dc80021cb1,243dfd60f45378e62d3aca3715579e91cba2bc99=3e8dbd0ae76ac2d3e581c1d0e12ba2e7,5f50b78e5ab3e589dc8200e2535b6aeb7aa00ac8=5bd12b7b5d386aff3bd54fe714fd39c9,e4fb065dc8474151f731bb1ffcc7423aebbc9569=6b8ceb92488b8a0d48e585b95b7812ed,22e930dcfa9521c3785925614c4b2fc6bf2d4f53=4a595a19b8ce6fcd9994af73fabec634,7b961d204d909f19f08b7fcc910ed67f28205085=aea4a813ea1c500af06da1f3fff3ec04,9a2d37e2e4e6851e646a61ddbe4dac26a9890c20=81ed5e0d22609cfaadd43feac703ff98,62e52384a5e55194b038dfdc78bc4b3842c822e8=44ae82749348fcb3e5becf8e87120eb9,fe8f61f3647023ae9d2b8967793d37319300dc0d=4a5b4c78e1f3c2bc8bebaa5f2a2dfd75,8ca01232cb8e5e95106f003c91d34730d65245e=ad81fb8b9504407cbef7c160bfaa9cfb,8ad52dcf5e06ee67b371ac5217ac50bc8e3ccf18=4f2ef0207d22edadd94667a20efa5ba8,a7a689a7f073cc64c93445b04a09c7dc4b384220=7dca006ad65341604f3bf9e4a4f3fb4c,765ff9b777c54430172ecc6f40b10e4a1ec070ec=41a37123273c7dc09caa4ab37b93f878,a348f611ea4e6f270bae00a97c4ba19a27a020db=d7a0ec85beffd20b74f1f74762b87541";
//    callC("setLicenses;"+licenses);
//	setTimeout("setLicenses()",5000);
}
