//
// log in functions
//
log('loading... login.js');

var orderScript;

/*
if (typeof cartScript === 'undefined'){
    $.getScript('js/cart.js');
}
*/

var orderTimer = null;

function order_timer_init(){
    log('init order_timer');
    orderTimer = setTimeout(function(){route('error-page')}, 10000);
}

function order_timmer_clear(){
    log('clear order_timer');
    clearTimeout(orderTimer);
}

function my_order(){
    // temp function to switch server
    tempSwitchSever();
    
    order_timer_init();
    var d = new Date();
    var args = new Object;
    var pid = $('#email').val();
    var emailCheck = pid.search("@");
    if (emailCheck != -1){
        pid = 'e|'+pid;
    }
    args.ParticipantId = pid
    args['Password'] = '';
    setTimeout(function(){ sendCommand('search_login',args,order_callback)}, 100);
}

function order_callback(data){
    order_timmer_clear();
    var result = null;

    try{
        result = data;
        log(JSON.stringify(result, null, '\t'));
    }catch(e){
        log('login 3rdparty ERROR: '+data);
        route('error-page');
        $('.msg').text(data);
        return;
    }
    if (result == null || typeof result == undefined ){
        log('network ERRROR: bad communitation with server');
        route('error-page');
        $('.msg').text('network ERRROR: bad communitation with server');
        return;
    }
    if (result.length < 1 || result['status'] === false){
        log('user not found');
        route('error-page');
        $('.msg').text('Your information was not found on the sever. Please try again.');
        return;
    }
    if (result['status'] === true){
        log('User Found, setting vars...');
        log(JSON.stringify(result, null, '\t'));
        currentPerson = result['data'];
        if (canShop(currentPerson['AttendeeType']) === true){
            clearFields();
            loadApp('shop');
            placingOrder = true;
        }else{
            jAlert('','CAN NOT PLACE ORDER FOR THIS PERSON');
            $('#email').val('');
            loadApp('order');
        }
    }
}

function canShop(personType){
    switch(personType){
        case 'Dealer Customer':
        case 'Store Owner':
            return true; 
        case 'Exhibitor':
        case 'Vendor':
        case 'Field':
        case 'Headquarters':
            return false;
    }
}
