log('loading capture.js......');
var lookup;
var lookupTimer = null;

function lookup_timer_init(){
    log('init lookup_timer');
    lookupTimer = setTimeout(function(){route('error-page')}, 10000);
}

function lookup_timmer_clear(){
    log('clear lookup_timer');
    clearTimeout(lookupTimer);
}

function my_lookup(){
    // temp function to switch servers
    tempSwitchSever();
    
    lookup_timer_init();
    var d = new Date();
    var args = new Object;
    if (lastTagId != ''){
        args.ParticipantId = lastTagId;
    }else{
        var pid = $('#email').val();
        var emailCheck = pid.search("@");
        if (emailCheck != -1){
            pid = 'e|'+pid;
        }
        args.ParticipantId = pid;
    }
    args['Password'] = '';
    setTimeout(function(){ sendCommand('search_capture',args,lookup_callback)}, 10);
}

function lookup_callback(data){
    lookup_timmer_clear();
    var result = null;


    try{
        result = data;
     //   log(JSON.stringify(result, null, '\t'));
    }catch(e){
        log('lookup ERROR: '+data);
        route('error-page');
        $('.msg').text(data);
        return;
    }
    if (result == null || typeof result == undefined){
        log('network ERRROR: bad communitation with server');
        route('error-page');
        $('.msg').text('Network ERROR: Bad communitation with server try again');
        return;
    }
    if (result.length < 1 || result['status'] == false){
        log('user not found');
        route('error-page');
        $('.msg').text('User not found. Enter ID again or try "Manual Entry"');
        return;
    }
    log('status = '+result.status);
    if (result.status === true){
        pad = {};
        log('User Found, setting vars...');
      //  log(JSON.stringify(result, null, '\t'));
        leadPerson = result['data'];
        clearFields();
        route('notes-page')
        $('.leadName').text(leadPerson['BadgeFirstName']+' '+leadPerson['BadgeLastName']);
        $('.identifier').text(leadPerson['AttendeeEmailAddress']);
        pad.BadgeFirstName = leadPerson['BadgeFirstName'];
        pad.BadgeLastName = leadPerson['BadgeLastName'];
        pad.ParticipantId = leadPerson['ParticipantId'];
        pad.AttendeeEmailAddress = leadPerson['AttendeeEmailAddress'];
        seenbefore(leadPerson['ExhibitsVisited']);
    }
}

function seenbefore(exhibitList){
    var exhibitor = loggedInPerson['CustomerStoreName'];
    var seen = $.inArray(exhibitor, exhibitList );
    log('seen = '+seen);
    if (seen >= 0){
        $('#notes-page').addClass('seen');
    }
}