// canvas colorpicker
var R, G, B;
function loadColorPicker(){
	
	var canvasPicker = document.getElementById('canvas_picker').getContext('2d');

	// create an image object and get it’s source
	var img = new Image();
	img.src = currentPicture;

	// copy the image to the canvas
	$(img).load(function(){
	  canvasPicker.drawImage(img,0,0,400,600);
	});

	$('#canvas_picker').click(function(event){
	  // getting user coordinates
	  var x = event.pageX - this.offsetLeft;
	  var y = event.pageY - this.offsetTop - 60;
	  // getting image data and RGB values
	  var img_data = canvasPicker.getImageData(x, y, 1, 1).data;
	  R = img_data[0];
	  G = img_data[1];
	  B = img_data[2];  
	  var rgb = R + ',' + G + ',' + B;
	  
	  eventData.greenscreen.R = R;
	  eventData.greenscreen.G = G;
	  eventData.greenscreen.B = B;
	  updateEvent();

	  // making the color the value of the input
	  $('#rgb').val(rgb);
	  $('#rgb').css('background-color', 'rgb('+rgb+')');
	  $('#mousePOS').val('x='+x+' y='+y);
	});
}