//
// log in functions
//
log('loading... reports.js');

var reportsScript;
var reportsTimer = null;
var ApprovedData, ApprovedDataFormat=[], PendingData, PendingDataFormat=[],CategoryDataA, CategoryDataP;

var Pending = false;

function reports_timer_init(){
    log('init reports_timer');
    reportsTimer = setTimeout(function(){route('error-page')}, 10000);
}

function reports_timmer_clear(){
    log('clear reports_timer');
    clearTimeout(reportsTimer);
}

function my_reports(){
    

    // temp function to switch server
    tempSwitchSever();
    reports_timer_init();
    var d = new Date();
    var args = new Object;
    var pid = loggedInPerson['ParticipantId'];
    args.ParticipantId = pid;
    args.reportDate = d;
    setTimeout(function(){ sendCommand('search_reports',args,reports_callback)}, 100);
}

function reports_callback(data){
    reports_timmer_clear();
    var result = null;

    try{
        result = data;
      //  log(JSON.stringify(result, null, '\t'));
    }catch(e){
        log('reports ERROR: '+data);
        route('error-page');
        $('.msg').text(data);
        return;
    }
    if (result == null || typeof result == undefined ){
        log('network ERRROR: bad communitation with server');
        route('error-page');
        $('.msg').text('network ERROR: bad communitation with server');
        return;
    }
    if (result.length < 1 || result['status'] === false){
        log('user not found');
        route('error-page');
        return;
    }
    if (result['status'] === true){
        log('User Found, setting reports...');
     //   log(JSON.stringify(result, null, '\t'));
        ApprovedData = result['data']['Order Status']['Approved'];
        PendingData = result['data']['Order Status']['Pending'];
        CategoryDataA = result['data']['Order Status']['Category Approved'];
        CategoryDataP = result['data']['Order Status']['Category Pending'];
        parseReportData();
    }
}

var chartApprovedOptions = {legendTemplate : "<ul class=\"legend center\"><% for (var i=0; i<segments.length; i++){%><li><span class=\"block\" style=\"background-color:<%=segments[i].fillColor%>\"></span><span class=\"rptlabel\"><%if(segments[i].label){%><%=segments[i].label%><%}%></span> <span class=\"money\"><%if(segments[i].value){%><%=segments[i].value%><%}%></span></li><%}%></ul>",
                            tooltipTemplate: "<%if (label){%><%=label%>: <%}%>$<%= value %>",
                            customTooltips: function(tooltip) {
                                if (!tooltip) {
                                    return;
                                }
                                // Tooltip Element
                                var tooltipEl = $('#a-tooltip');
                                // Hide if no tooltip
                                if (!tooltip) {
                                    tooltipEl.css({
                                        opacity: 0
                                    });
                                    return;
                                }
                                // Set caret Position
                                tooltipEl.removeClass('above below');
                                tooltipEl.addClass(tooltip.yAlign);
                                // Set Text
                                tooltipEl.html(tooltip.text);
                                // Find Y Location on page
                                var top;
                                if (tooltip.yAlign == 'above') {
                                    top = tooltip.y - tooltip.caretHeight - tooltip.caretPadding;
                                } else {
                                    top = tooltip.y + tooltip.caretHeight + tooltip.caretPadding;
                                }
                                // Display, position, and set styles for font
                                tooltipEl.css({
                                    opacity: 1,
                                    left: tooltip.chart.canvas.offsetLeft + tooltip.x + 'px',
                                    top: tooltip.chart.canvas.offsetTop + top + 'px',
                                    fontFamily: tooltip.fontFamily,
                                    fontSize: tooltip.fontSize,
                                    fontStyle: tooltip.fontStyle,
                                });  
                            }
                        };
var chartPendingOptions = {legendTemplate : "<ul class=\"legend center\"><% for (var i=0; i<segments.length; i++){%><li><span class=\"block\" style=\"background-color:<%=segments[i].fillColor%>\"></span><span class=\"rptlabel\"><%if(segments[i].label){%><%=segments[i].label%><%}%></span> <span class=\"money\"><%if(segments[i].value){%><%=segments[i].value%><%}%></span></li><%}%></ul>",
                            tooltipTemplate: "<%if (label){%><%=label%>: <%}%>$<%= value %>",
                            customTooltips: function(tooltip) {
                                if (!tooltip) {
                                    return;
                                }
                                // Tooltip Element
                                var tooltipEl = $('#p-tooltip');
                                // Hide if no tooltip
                                if (!tooltip) {
                                    tooltipEl.css({
                                        opacity: 0
                                    });
                                    return;
                                }
                                // Set caret Position
                                tooltipEl.removeClass('above below');
                                tooltipEl.addClass(tooltip.yAlign);
                                // Set Text
                                tooltipEl.html(tooltip.text);
                                // Find Y Location on page
                                var top;
                                if (tooltip.yAlign == 'above') {
                                    top = tooltip.y - tooltip.caretHeight - tooltip.caretPadding;
                                } else {
                                    top = tooltip.y + tooltip.caretHeight + tooltip.caretPadding;
                                }
                                // Display, position, and set styles for font
                                tooltipEl.css({
                                    opacity: 1,
                                    left: tooltip.chart.canvas.offsetLeft + tooltip.x + 'px',
                                    top: tooltip.chart.canvas.offsetTop + top + 'px',
                                    fontFamily: tooltip.fontFamily,
                                    fontSize: tooltip.fontSize,
                                    fontStyle: tooltip.fontStyle,
                                });  
                            }
                        };
var chartCategoryAOptions = {legendTemplate : "<ul class=\"legend center\"><% for (var i=0; i<segments.length; i++){%><li><span class=\"block\" style=\"background-color:<%=segments[i].fillColor%>\"></span><span class=\"rptlabel\"><%if(segments[i].label){%><%=segments[i].label%><%}%></span> <span class=\"money\"><%if(segments[i].value){%><%=segments[i].value%><%}%></span></li><%}%></ul>",
                            tooltipTemplate: "<%if (label){%><%=label%>: <%}%>$<%= value %>",
                            customTooltips: function(tooltip) {
                                if (!tooltip) {
                                    return;
                                }
                                // Tooltip Element
                                var tooltipEl = $('#ac-tooltip');
                                // Hide if no tooltip
                                if (!tooltip) {
                                    tooltipEl.css({
                                        opacity: 0
                                    });
                                    return;
                                }
                                // Set caret Position
                                tooltipEl.removeClass('above below');
                                tooltipEl.addClass(tooltip.yAlign);
                                // Set Text
                                tooltipEl.html(tooltip.text);
                                // Find Y Location on page
                                var top;
                                if (tooltip.yAlign == 'above') {
                                    top = tooltip.y - tooltip.caretHeight - tooltip.caretPadding;
                                } else {
                                    top = tooltip.y + tooltip.caretHeight + tooltip.caretPadding;
                                }
                                // Display, position, and set styles for font
                                tooltipEl.css({
                                    opacity: 1,
                                    left: tooltip.chart.canvas.offsetLeft + tooltip.x + 'px',
                                    top: tooltip.chart.canvas.offsetTop + top + 'px',
                                    fontFamily: tooltip.fontFamily,
                                    fontSize: tooltip.fontSize,
                                    fontStyle: tooltip.fontStyle,
                                });  
                            }
                        };
var chartCategoryPOptions = {legendTemplate : "<ul class=\"legend center\"><% for (var i=0; i<segments.length; i++){%><li><span class=\"block\" style=\"background-color:<%=segments[i].fillColor%>\"></span><span class=\"rptlabel\"><%if(segments[i].label){%><%=segments[i].label%><%}%></span> <span class=\"money\"><%if(segments[i].value){%><%=segments[i].value%><%}%></span></li><%}%></ul>",
                            tooltipTemplate: "<%if (label){%><%=label%>: <%}%>$<%= value %>",
                            customTooltips: function(tooltip) {
                                if (!tooltip) {
                                    return;
                                }
                                // Tooltip Element
                                var tooltipEl = $('#pc-tooltip');
                                // Hide if no tooltip
                                if (!tooltip) {
                                    tooltipEl.css({
                                        opacity: 0
                                    });
                                    return;
                                }
                                // Set caret Position
                                tooltipEl.removeClass('above below');
                                tooltipEl.addClass(tooltip.yAlign);
                                // Set Text
                                tooltipEl.html(tooltip.text);
                                // Find Y Location on page
                                var top;
                                if (tooltip.yAlign == 'above') {
                                    top = tooltip.y - tooltip.caretHeight - tooltip.caretPadding;
                                } else {
                                    top = tooltip.y + tooltip.caretHeight + tooltip.caretPadding;
                                }
                                // Display, position, and set styles for font
                                tooltipEl.css({
                                    opacity: 1,
                                    left: tooltip.chart.canvas.offsetLeft + tooltip.x + 'px',
                                    top: tooltip.chart.canvas.offsetTop + top + 'px',
                                    fontFamily: tooltip.fontFamily,
                                    fontSize: tooltip.fontSize,
                                    fontStyle: tooltip.fontStyle,
                                });  
                            }
                        };

function parseReportData(){
    log('parseReportData');
    ApprovedDataFormat = [];
    PendingDataFormat = [];
    CategoryDataAFormat = [];
    CategoryDataPFormat = [];
    
    var sum1 = 0; 
    $.each(ApprovedData, function (index, data) {
        log(index+' '+JSON.stringify(data));
        var myColor = colorGen();
        sum1 += Number(data['amount']);
        if (data['numcarts'] > 0){
            myLabel = data['name']+'  '+data['numcarts']; 
        }else{
            myLabel = data['name'];
        }
        ApprovedDataFormat.push({'value': Number(data['amount']),'color': myColor,'highlight': myColor,'label': myLabel });
    });
    sum1 = sum1.toFixed(2);
    sum1 = addCommas(sum1);
    $('#Approved-report .revenue').text('Total: $'+sum1);
    
    var sum2 = 0;
    $.each(PendingData, function (index, data) {
        log(index+' '+JSON.stringify(data));
        var myColor = colorGen();
        sum2 += Number(data['amount']);
        var myLabel;
        if (data['numcarts'] > 0){
            myLabel = data['name']+'  '+data['numcarts']; 
        }else{
            myLabel = data['name'];
        }
        PendingDataFormat.push({'value': Number(data['amount']),'color': myColor,'highlight': myColor,'label': myLabel });
    });
    sum2 = sum2.toFixed(2);
    sum2 = addCommas(sum2);
    $('#Pending-report .revenue').text('Total: $'+sum2);

    var sum3 = 0;
    log('CategoryDataA '+JSON.stringify(CategoryDataA, null,'\t'));
    if ($.isEmptyObject(CategoryDataA) === false){ 
        $.each(CategoryDataA, function (index, data) {
            log(index+' '+JSON.stringify(data));
            var myColor = colorGen();
            sum3 += Number(data['amount']);
            var myLabel;
            if (data['numcarts'] > 0){
                myLabel = data['name']+'  '+data['numcarts']; 
            }else{
                myLabel = data['name'];
            }
            log('pushing');
            CategoryDataAFormat.push({'value': Number(data['amount']),'color': myColor,'highlight': myColor,'label': myLabel });
        });
        sum3 = sum3.toFixed(2);
        sum3 = addCommas(sum3);
        $('#Category-approved .revenue').text('Total: $'+sum3);
    }

    var sum4 = 0;
    log('CategoryDataP '+JSON.stringify(CategoryDataP, null,'\t'));
    if ($.isEmptyObject(CategoryDataP) === false ){
        $.each(CategoryDataP, function (index, data) {
            log(index+' '+JSON.stringify(data));
            var myColor = colorGen();
            sum4 += Number(data['amount']);
            var myLabel;
            if (data['numcarts'] > 0){
                myLabel = data['name']+'  '+data['numcarts']; 
            }else{
                myLabel = data['name'];
            }
            CategoryDataPFormat.push({'value': Number(data['amount']),'color': myColor,'highlight': myColor,'label': myLabel });
        });
        sum4 = sum4.toFixed(2);
        sum4 = addCommas(sum4);
        $('#Category-pending .revenue').text('Total: $'+sum4);
    }

    log(JSON.stringify(ApprovedDataFormat, null,'\t'));
    log(JSON.stringify(PendingDataFormat, null,'\t'));
    if (Pending != true){
        route('Approved-report');
    }else{
        route('Pending-report');
    }
}

function colorGen(){
    return "#000000".replace(/0/g,function(){return (~~(Math.random()*16)).toString(16);});
}
var myApprovedChart = '';
function createApprovedReports(){
    log('myApprovedChart = '+myApprovedChart);
    if (myApprovedChart){
        log('myApprovedChart inside');
        myApprovedChart.clear();
        myApprovedChart.destroy();
    }
    log('------ creatingApprovedReports');
    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $('#myApprovedChart').get(0).getContext("2d");
    // This will get the first returned node in the jQuery collection.
    log('chart Data = '+JSON.stringify(ApprovedDataFormat));
    myApprovedChart = new Chart(ctx).Pie(ApprovedDataFormat,chartApprovedOptions); 

    // generate legend
    var legendHolder = document.createElement('div');
    legendHolder.innerHTML = myApprovedChart.generateLegend();
    $('#Approved-report .legend').remove();
    $('#Approved-report .chartHolder').append(legendHolder);
    destroyTooltips();
    $("#myApprovedChart").on('click',function(evt){
            log('touch');
            var activePoints = myApprovedChart.getSegmentsAtEvent(evt);
            var segment = activePoints[0].label;
            var ind = '';
            $.each(ApprovedDataFormat, function(index, data){
                if (data.label === segment){
                    ind = index;
                }
            });
            log('index = '+ind);
            if (ind !== ''){
                var moreDetails = $.isEmptyObject(ApprovedData[ind]['detail']);
                if (moreDetails != true){
                    
                    log(JSON.stringify(ApprovedData[ind]['detail'], null, '\t'));
                    ApprovedData = ApprovedData[ind]['detail'];
                    parseReportData();
                }
            }
        }
    );

}

var myPendingChart = '';
function createPendingReports(){
    log('myPendingChart = '+myPendingChart);
    if (myPendingChart){
        log('myPendingChart inside');
        myPendingChart.clear();
        myPendingChart.destroy();
    }
    log('------ creatingPendingReports');
    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $('#myPendingChart').get(0).getContext("2d");
    // This will get the first returned node in the jQuery collection.
    log('chart Data = '+JSON.stringify(PendingDataFormat));
    myPendingChart = new Chart(ctx).Pie(PendingDataFormat,chartPendingOptions 


    ); 

    // generate legend
    var legendHolder = document.createElement('div');
    legendHolder.innerHTML = myPendingChart.generateLegend();
    $('#Pending-report .legend').remove();
    $('#Pending-report .chartHolder').append(legendHolder);
    destroyTooltips();
    $("#myPendingChart").on('click',function(evt){
            var activePoints = myPendingChart.getSegmentsAtEvent(evt);
            var segment = activePoints[0].label;
            var ind = '';
            $.each(PendingDataFormat, function(index, data){
                if (data.label === segment){
                    ind = index;
                }
            });
            log('index = '+ind);
            if (ind !== ''){
                var moreDetails = $.isEmptyObject(PendingData[ind]['detail']);

                if (moreDetails != true){
                    
                    log(JSON.stringify(PendingData[ind]['detail'], null, '\t'));
                    PendingData = PendingData[ind]['detail'];
                    parseReportData();
                }
            }
        }
    );

}


var myCategoryAChart = '';
function createCategoryAReports(){
    log('myCategoryAChart = '+myCategoryAChart);

    log('------ creatingCategoryReports');
    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $('#myCategoryAChart').get(0).getContext("2d");
    // This will get the first returned node in the jQuery collection.
    log('chart Data = '+JSON.stringify(CategoryDataAFormat));
    myCategoryAChart = new Chart(ctx).Pie(CategoryDataAFormat,chartCategoryAOptions); 

    // generate legend
    var legendHolder = document.createElement('div');
    legendHolder.innerHTML = myCategoryAChart.generateLegend();
    $('#Category-approved .legend').remove();
    $('#Category-approved .chartHolder').append(legendHolder);
    destroyTooltips();
    $("#myCategoryAChart").on('click',function(evt){
            var activePoints = myCategoryAChart.getSegmentsAtEvent(evt);
            var segment = activePoints[0].label;
            var ind = '';
            $.each(CategoryDataAFormat, function(index, data){
                if (data.label === segment){
                    ind = index;
                }
            });
            log('index = '+ind);
            if (ind !== ''){
                var moreDetails = $.isEmptyObject(CategoryDataA[ind]['detail']);

                if (moreDetails != true){
                    log(JSON.stringify(CategoryDataA[ind]['detail'], null, '\t'));
                    CategoryData = CategoryDataA[ind]['detail'];
                    parseReportData();
                }
            }
        }
    );

}

var myCategoryPChart = '';
function createCategoryPReports(){
    log('myCategoryPChart = '+myCategoryPChart);

    log('------ creatingCategoryReports');
    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $('#myCategoryPChart').get(0).getContext("2d");
    // This will get the first returned node in the jQuery collection.
    log('chart Data = '+JSON.stringify(CategoryDataPFormat));
    myCategoryPChart = new Chart(ctx).Pie(CategoryDataPFormat,chartCategoryPOptions); 

    // generate legend
    var legendHolder = document.createElement('div');
    legendHolder.innerHTML = myCategoryPChart.generateLegend();
    $('#Category-pending .legend').remove();
    $('#Category-pending .chartHolder').append(legendHolder);
    destroyTooltips();
    $("#myCategoryPChart").on('click',function(evt){
            var activePoints = myCategoryPChart.getSegmentsAtEvent(evt);
            var segment = activePoints[0].label;
            var ind = '';
            $.each(CategoryDataPFormat, function(index, data){
                if (data.label === segment){
                    ind = index;
                }
            });
            log('index = '+ind);
            if (ind !== ''){
                var moreDetails = $.isEmptyObject(CategoryDataP[ind]['detail']);

                if (moreDetails != true){
                    log(JSON.stringify(CategoryDataP[ind]['detail'], null, '\t'));
                    CategoryPData = CategoryDataP[ind]['detail'];
                    parseReportData();
                }
            }
        }
    );

}

function destroyTooltips(){
    $('#p-tooltip').remove();
    $('#Pending-report').append('<div id="p-tooltip"></div>');
    $('#a-tooltip').remove();
    $('#Approved-report').append('<div id="a-tooltip"></div>');
    $('#ac-tooltip').remove();
    $('#Category-approved').append('<div id="ac-tooltip"></div>');
    $('#pc-tooltip').remove();
    $('#Category-pending').append('<div id="pc-tooltip"></div>');
}

function moneyFixed(){
    $( '.money' ).each(function( index ) {
        var money  = $( this ).text();
        money = money.replace('$','');
        money = Number(money);
        money = money.toFixed(2);
        money = addCommas(money);
        $(this).text('$'+money);
    });
}
