// This file contains all routing and branching for an app
console.log('loading router.js');

// The page the app starts on...
var startingPage = 'login'; 
var panelEntryPage = 'login-page';
var currentCart = [];
var currentItem = {};
var currentPerson = {};
var placingOrder = false;
var db;
var connected = true;
var ua = navigator.userAgent.toLowerCase();
var isAndroid = ua.indexOf("android") > -1;

function route(branchTo) {
    log("route - called with branchTo = "+branchTo+", mode = "+mode+", currentPage = "+currentPage);

    // Where to hide next button
    if (['panel', 'settings', 'thanks', 'searchResults', 'categories', 'manufacturer', 'menu', 'productDetail', 'shopPage', 'cart', 'error-page', 'login-page', 'lookup-page', 'start-page', 'stub', 'cartList', 'getCarts', 'cartDetail', 'Pending-report', 'Approved-report', 'reports', 'Category-approved', 'Category-pending'].indexOf(branchTo) !== -1) {
        $('.next').hide();
    } else {
        $('.next').show();
    }
    

    if ( mode === 'login'){
        if (branchTo === 'lookup-page'){
          
        }else if (branchTo === 'error-page'){
            setTimeout(function () {clearFields();loadApp(startingPage)}, 3500);
        }
    } else if (mode === 'order'){
        if (branchTo === 'error-page'){
             setTimeout(function () {clearFields();loadApp('settings')}, 3500);
        }

    } else if (mode === 'shop'){
        if (branchTo === 'shopPage'){
          //  log('currentPerson = '+ JSON.stringify(currentPerson, null, '\t'));
            manufacturer = '';
            paging = false;
            cartItemQuanity();
        }else if (branchTo === 'searchResults'){
            update();
            
        }else if (branchTo === 'productDetail'){
            log('currentItem = '+ JSON.stringify(currentItem));
        }else if (branchTo === 'cart'){
            log('placingOrder = '+ placingOrder);
            if(placingOrder === true){
                $('label[for="cartPassword"]').text('Password for '+currentPerson['BadgeFirstName']+' '+currentPerson['BadgeLastName']);
            }
            setTimeout(function(){displayCartList()}, 500);
        }else if (branchTo === 'thanks'){
            $('.shoppingCart').hide();
            currentCart = [];
            setTimeout(function(){loadApp('settings')}, 3000);
        }
        log('leaving shop...ROUTE');
    // mode capture
    } else if ( mode === 'capture'){
        if (branchTo === 'lookup-page'){
            if (connected === true){
                my_lookup();
            }else{
                log('no internets');
                $('.identifier').text(lastTagId);
                branchTo = 'notes-page';
                pad['ParticipantID'] = lastTagId;
                $('.next').show();
            }
        } else if (branchTo === 'stub'){
            $('.leadName').text($('#fname').val()+' '+$('#lname').val());
            $('.identifier').text($('#email').val());
            branchTo = 'notes-page';
            $('.next').show();
        }else if (branchTo === 'thanks'){
            // switch server
            tempSwitchSever();
            // end switch

            // add in send to server stuff
            var d = new Date();
            var args = new Object;
            args.leadDate = d;
            args.ParticipantId = loggedInPerson['ParticipantId'];
            args.lead = pad;
         //   log('lead = '+JSON.stringify(args, null, '\t'));
            setTimeout(function(){ sendCommand('submit_lead',args)}, 10);
            setTimeout(function () {clearFields();loadApp('capture')}, 3000);
            
        }else if (branchTo === 'error-page'){
            setTimeout(function () {clearFields();loadApp('capture')}, 3500);
        }
    // mode approver
    } else if (mode === 'approver'){
        if (branchTo === 'getCarts'){
            getAllCarts();
        }
        if (branchTo === 'thanks'){
            submitCartUpdate();
            setTimeout(function () {clearFields();loadApp('approver')}, 3000);
        }
    // mode reports
    } else if (mode === 'reports'){
        if (branchTo === 'reports'){
            my_reports();
        }
        if(branchTo === 'Approved-report'){
            Pending = false;
            setTimeout(function(){createApprovedReports()}, 300);
            setTimeout(function(){moneyFixed()},400);
        }
        if(branchTo === 'Pending-report'){
            Pending = true;
            setTimeout(function(){createPendingReports()}, 300);
            setTimeout(function(){moneyFixed()},400);
        }
        if(branchTo === 'Category-approved'){
            Category = true;
            setTimeout(function(){createCategoryAReports()}, 300);
            setTimeout(function(){moneyFixed()},400);
        }
        if(branchTo === 'Category-pending'){
            Category = true;
            setTimeout(function(){createCategoryPReports()}, 300);
            setTimeout(function(){moneyFixed()},400);
        }
        if (branchTo === 'error-page'){
            setTimeout(function () {clearFields();loadApp('settings')}, 3500);
        }
    } else if (branchTo === 'settings' && $('#settings').length < 1) {
        clearFields();
        loadApp(startingPage);
        return;

    } else if (branchTo === undefined) {

        if(typeof loadApp != "undefined") loadApp(startingPage);
        return;
        
    }

    changePage(branchTo);
    log("route - done.");
}

function clearFields() {
    $('.fullname').text('');
    $('.identifier').text('');
    pad = {};
    currentGuest = '';
    lastTagId = '';
    myPhoto = null;
    canvas = null;
    callC('setRfidStop;{}');
    countsPersist();
    fs_tag.init(tagmapping);
}
