function startRfidGreenMulti()
{
    $("#greenStatus").html("");
    $("#guestID").val("");
    $("#tagCount").css('display','inline-block');
    $("#greenDone").show();
    $("#greenScans").html("0");
    photoTags = [];

    rfidReadSuccess = afterRfidReadLatestVideoMulti;
    rfidTransition = '';
    callC("setRfidPending");
}

function afterRfidReadLatestVideoMulti()
{
    if(lastTagId != "")
    {
        if(jQuery.inArray(lastTagId,photoTags) == -1)
        {
            log("gotTag unique id: "+lastTagId);
            photoTags.push(lastTagId);
        }
    }

    var greenScans = photoTags.length;
    log("gotTag current array size: "+greenScans);
    $('#greenScans').text(greenScans.toString());
    callC("setRfidPending");
    log("finished setting rfid pending");
}

function rfidGreenMultiDone()
{
    if(photoTags.length > 0)
    {
        $(".tagInfo").hide();
        afterRfidReadLatestVideo();
    }
    else $("#greenStatus").html("No tags scanned. Please scan your tag");
}

function startRfidGreen()
{
    $("#greenStatus").html("");
    $("#guestID").val("");
    rfidReadSuccess = afterRfidReadLatestVideo;
    callC("setRfidPending;");
}

function continueGreen()
{
    $("#greenStatus").html("");
    var guestID = $("#guestID").val();
    guestID = guestID.replace(/[^a-zA-Z0-9]/g,'_');

    var validInput = false;

    var phoneSeq = /^[2-9]\d{2}[2-9]\d{2}\d{4}$/;
    var validPhone = guestID.match(phoneSeq) !== null;
    if(validPhone) 
    {
        validInput = true;
        greenIDType = "Phone";
    }

    if(guestID.length == 5)
    {
        validInput = true;
        greenIDType = "url_id";
    }

    var lbadgeid = guestID.length;
    var checkNum = guestID.substring(0, lbadgeid-1);
    checkNum = ModEleven(checkNum);

    if(checkNum == guestID) 
    {
        validInput = true;
        greenIDType = "RFID Tag ID";
    }

    if(!validInput)
    {
        $("#greenStatus").html("Invalid guest id. Please try again.");
        return;
    }

    var timeStamp = new Date().getTime();
    callC("getLatestVideoFromDocs;"+guestID + "," + timeStamp);
}

function ModEleven(serialNumber) 
{
    var sArray = new Array();
    sArray = serialNumber.split('');
    var slength = sArray.length;
    var cal = 0;
    var m = 0;
    for (i=0; i<slength; i++)
          {
          m = (slength-i)+1;
          cal = cal+(sArray[i]*m);
          }
    var q = 0;
    q = Math.floor(cal/11);
    var r = 0;
    r = cal-(q*11);
    r = 11-r;
    if (r < 10) {
        r = r;
    }else{
        r = r-10;
    }
    return serialNumber+r;
}

function afterRfidReadLatestVideo()
{
  var timeStamp = new Date().getTime();
  callC("getLatestVideoFromDocs;"+lastTagId + "," + timeStamp);
}

var greenIDType = "";
function latestVideoFromDocsCallback(filePath)
{
    var tmpID;
    if(filePath == "")
    {
        filePath = filePath.replace(/\\/g, "\\\\");
        log("latestVideo error. no files found");
        $("#greenStatus").html("No files found. Please try again.");
        return;
    }
    log("latestVideoFromDocsCallback. " + filePath);

    callC("runShellCommand;C:\\Program Files\\SyncToy 2.1\\SyncToyCmd.exe%%-R");

    var d = new Date();
    var args = new Object;

    var msg = "Video";
    var i = lastTagId;
    var I = photoTags.indexOf(i);
    photoTags.splice(I,1);

    args.guest_id = lastTagId;
    args.id_type = "RFID Tag ID";

    var context = "pepsi-gsv-msg";//"GreenScreen";
    var recordVisitContext = "VGRS-PEP-1";

    var guestID = $("#guestID").val();
    if(guestID != "")
    {
        if(greenIDType == "") greenIDType = "Guest ID";
        args.guest_id = guestID;
        currentGuest = guestID;
        args.id_type = greenIDType;
    }

    sendRecordVisitGivenType(args.guest_id,recordVisitContext,args.id_type);

    args.photo_name = filePath;
    args.time_stamp = d.getTime();
    args.buddies = photoTags;

    args.photo = "%%photo%%";
    args.message_name = msg;
    log("latestVideoFromDocsCallback. args = "+JSON.stringify(args));
    sendCommand("upload_photo",args);

    $("#guestID").val("");
    $("#greenStatus").html("Video found and processed.");
}