var sqliteDB;
var wantedDBFile = "zip.db";
function initDatabase(callback)
{
try {
	log("initDatabase.");
	var xhr = new XMLHttpRequest();
	xhr.open('GET', wantedDBFile, true);
	xhr.responseType = 'arraybuffer';
	 
	xhr.onload = function(e) {
		log("initDatabase. database received");
	  	var responseArray = new Uint8Array(this.response);
	  	sqliteDB = new SQL.Database(responseArray);
	  	log("initDatabase. database loaded");
	  	if(callback != null) callback();
	};
	xhr.send();
    }
    catch(err){log("err: " + err);}
}

function exportDatabase()
{
	log("NEEDS IMPLEMENTATION");
}

//TEST FUNCTIONS
function zipDBLoadComplete()
{
	getStateList();
}

function getStateList()
{
	log("getStateList.");
	$("#chooseState").empty();
	var stmt = sqliteDB.prepare("SELECT StateCode FROM zipCodes GROUP BY StateCode");
   	while(stmt.step()) 
    { 
        var row = stmt.getAsObject();
        var stateCode = row['StateCode'];
		$('#chooseState').append(new Option(stateCode, stateCode, true, true));
    }
	stmt.free();

	log("getStateList. query complete");
}

function getZipAndDisplay()
{
	getZipAndDisplay2();
}

function getZipAndDisplay2()
{
	log("getZipAndDisplay.");
	$("#sqlData").html("");
	var a = performance.now();

	var state = $("#chooseState").val();
	var count = $("#count").val();
	if(count == "") count = "50";
	$("#count").val(count);

	var stmt = sqliteDB.prepare("SELECT * FROM zipCodes WHERE StateCode = '" + state + "' LIMIT " + count);
	log("SELECT * FROM zipCodes WHERE StateCode = '" + state + "' LIMIT " + count);
   	while(stmt.step()) 
    { 
        var row = stmt.getAsObject();
        $("#sqlData").html($("#sqlData").html() + row['City'] + ", " + row['StateCode'] + " " + row['ZipCode'] + "<br/>");
    }
	stmt.free();

	log("getZipAndDisplay. query complete");
	var b = performance.now();
	$("#execTime").html("Execution Time: " + msToTime((b-a)));
}

function msToTime(s) {

  function addZ(n) {
    return (n<10? '0':'') + n;
  }

  var ms = s % 1000;
  s = (s - ms) / 1000;
  var secs = s % 60;
  s = (s - secs) / 60;
  var mins = s % 60;
  var hrs = (s - mins) / 60;

  return addZ(mins) + ':' + addZ(secs) + '.' + ms;
}